\name{barplot.pps}
\alias{barplot.pps}
\title{Intensity Bar Graph}
\description{ Barplot of the intensities of probe pairs with PM and MM
  in different colors}
 }
\usage{
barplot.pps(pps, xlab="Probe pair", ylab="Intensity",main=NA,col.pm="red",col.mm="blue",beside=TRUE,names.arg="pp",...)
}
\arguments{
  \item{pps}{an object of class \code{pps}.}
  \item{xlab}{The label for the x-axis.}
  \item{ylab}{The label for the y-axis.}
  \item{main}{The main label for the plot. If NA, the name of the
    pps is used.}
  \item{col.pm}{color for the perfect matches. Default is red.}
  \item{col.mm}{color for the mismatches. Default is blue.}
  \item{beside}{should the bars be plotted besides eachothers ?}
  \item{names.arg}{The name on the x-axis. If "pp", the number of the
    probepair is used}
  \item{...}{arguments for the function 'barplot'}
}
\author{
  Laurent Gautier
}
\references{
  \item Affymetrix Users Manual. GeneChip version 4.0.
}
\examples{

  data(listcel)
  data(CDF.example)

  ## getting a pps object
  p <- get.pps("A28102_at",CDF.example,listcel[[1]])

  ## plot
  barplot.pps(p)

  ## identical to the previous statement
  ## (thanks to the object flavored features in R)
  barplot(p)


  ## let's compare the behaviour of Mr. Affymetrix's controls
  namesspot <- c("AFFX-BioC-5_at","AFFX-BioC-3_at")
  p <- lapply(namesspot,get.pps,CDF.example,listcel[[1]])
  ylimi <- range(min(unlist(p)), max(unlist(p)))
  par(mfrow=c(2,2))
  for(i in 1:length(namesspot)) barplot(p[[i]],ylim=ylimi)
}
\keyword{hplot}
