\name{get.pps}
\alias{get.pps}
\title{Get the values for a probe pair set}
\description{
  Gets the values for a given probe pair set.
}
\usage{
get.pps(name,cdf,cel)
}
\arguments{
  \item{name}{The name of the probe pair you are interested in.}
  \item{cdf}{A \code{\link{CDF}} object. Used to determine where data corresponding to name can be found.}
  \item{cel}{A \code{\link{CEL}} object. Used to get the actual values.}
}
\value{
  A probe pair set (pps) object.
}
\author{
  L. Gautier <laurent@cbs.dtu.dk>
}
\examples{
  ## loading data
  data(listcel)
  ## or if you want to use your own CEL file
  ## try the function read.celfile
  mycel <- listcel[[1]]

  data(CDF.example)
  ## or if you want to use your own preprocessed CDF file
  ## try the function read.celfile

  ## getting a pps.val object
  p <- get.pps("A28102_at",CDF.example,mycel)

  str(p)
  plot(p)
}
\keyword{manip}
\keyword{classes}



