\name{plot.pps}
\alias{plot.pps}
\title{Intensity Line Graph}
\description{
  Plot probe pair set values.  }
\usage{
plot.pps(pps, xlab="Probe pair", ylab="Intensity",
         main=attr("name",pps),ratio=FALSE,
         col.pm="red", col.mm="blue", col.ratio="green", ylim=range(pps))
}
\arguments{
  \item{pps}{an object of class \code{pps}.}
  \item{xlab}{The label on the x-axis.}
  \item{ylab}{The label on the y-axis.}
  \item{main}{The main title for the plot.}
  \item{ratio}{logical value. If ratio is TRUE, PM/MM ratios are plotted.}
  \item{col.pm}{Color for the PMs.}
  \item{col.mm}{Color for the MM.}
  \item{col.ratio}{Color for the ratio (only relevant when ratio=TRUE)}
  \item{ylim}{Range for the y-axis}
}
\author{
  Laurent Gautier
}
\examples{
  ## loading data
  data(listcel)
  data(CDF.example)

  ## getting a pps object from the first CEL in listcel
  p <- get.pps("A28102_at", CDF.example, listcel[[1]])

  ## plot
  plot.pps(p)
  ## identical to the previous statement
  plot(p)
}
\keyword{hplot}
